"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var models_1 = require('../models');
var enums_1 = require('../enums');
var BYTES_IN_ONE_MB = 1048576;
var ImageUploadComponent = (function () {
    function ImageUploadComponent(cd) {
        var _this = this;
        this.onRemove = new core_1.EventEmitter();
        this.onAdd = new core_1.EventEmitter();
        this.onError = new core_1.EventEmitter();
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
        this._fileReaderLoad = function () {
            var data = _this.fileReader.result;
            var img = new models_1.ImageUpload(data, _this.currentFile.name, _this.currentFile.size);
            if (!_this._validateFilesize(img))
                return;
            _this._onAdd(img);
            _this.files.push(img);
            _this.cd.viewToModelUpdate(_this.files);
        };
        this._validateFilesize = function (image) {
            debugger;
            if (_this.config.maxFilesizeSum != null) {
                var total = (_this.totalUploadedSize + image.size) / BYTES_IN_ONE_MB;
                if (total > _this.config.maxFilesizeSum) {
                    _this._onError({ type: enums_1.ErrorType.ExceedsUploadLimit, message: "Limit is set to " + _this.config.maxFilesizeSum + " MB, got " + total + " MB." });
                    return false;
                }
            }
            return true;
        };
        this.cd = cd;
        cd.valueAccessor = this;
        this.files = [];
        this.config = new models_1.ImageUploadConfiguration();
        this.fileReader = new FileReader();
        this.fileReader.addEventListener('load', this._fileReaderLoad);
    }
    ImageUploadComponent.prototype.ngOnInit = function () {
        this._processOptions();
    };
    Object.defineProperty(ImageUploadComponent.prototype, "totalUploadedSize", {
        get: function () {
            var total = 0;
            for (var i = 0; i < this.files.length; i++) {
                total += this.files[i].size;
            }
            return total;
        },
        enumerable: true,
        configurable: true
    });
    ImageUploadComponent.prototype.writeValue = function (value) {
    };
    ImageUploadComponent.prototype.upload = function (files, elem) {
        var filesLength = files.length;
        if (filesLength > 0) {
            for (var i = 0; i < filesLength; i++) {
                this.currentFile = files[i];
                this.fileReader.readAsDataURL(this.currentFile);
            }
        }
        elem.value = '';
    };
    ImageUploadComponent.prototype.removeImage = function (index) {
        var image = this.files.splice(index, 1);
        this.cd.viewToModelUpdate(this.files);
        this._onRemove(image[0]);
    };
    ImageUploadComponent.prototype._processOptions = function () {
        if (this.opts != null) {
            if (this.opts.addSectionHeader != null) {
                this.config.addSectionHeader = this.opts.addSectionHeader;
            }
            if (this.opts.uploadedHeader != null) {
                this.config.uploadedHeader = this.opts.uploadedHeader;
            }
            if (this.opts.buttonLabel != null) {
                this.config.buttonLabel = this.opts.buttonLabel;
            }
            if (this.opts.accepts != null) {
                this.config.accepts = this.opts.accepts;
            }
            if (this.opts.maxFilesizeSum != null) {
                this.config.maxFilesizeSum = this.opts.maxFilesizeSum;
            }
        }
    };
    ImageUploadComponent.prototype._onRemove = function (image) {
        this.onRemove.emit(image);
    };
    ImageUploadComponent.prototype._onAdd = function (image) {
        this.onAdd.emit(image);
    };
    ImageUploadComponent.prototype._onError = function (error) {
        this.onError.emit(error);
    };
    ImageUploadComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    ImageUploadComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    __decorate([
        core_1.Input('upload-config'), 
        __metadata('design:type', Object)
    ], ImageUploadComponent.prototype, "opts", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ImageUploadComponent.prototype, "onRemove", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ImageUploadComponent.prototype, "onAdd", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ImageUploadComponent.prototype, "onError", void 0);
    ImageUploadComponent = __decorate([
        core_1.Component({
            selector: "image-upload[ngModel]",
            template: "\n        <div class=\"row images-detail\">\n            <div class=\"col-xs-12\">\n\n            <h4 *ngIf=\"cd.viewModel.length > 0\">{{config.uploadedHeader}}</h4>\n\n            <div class=\"upload-container\">\n                <div class=\"upload-item\" *ngFor=\"let image of cd.viewModel; let i = index;\">\n                    <div class=\"image-area\">\n                        <div class=\"upload-item-overlay\">\n                            <span class=\"remove-upload\" (click)=\"removeImage(i)\">\u00D7</span>\n                        </div>\n                        <img [src]=\"image.data\" style=\"max-height: 100px; max-width: 100px;\" />\n                    </div>\n\n                    <p class=\"upload-title\">{{image.fileName}}</p>\n                    <p class=\"upload-file-size\">{{image.size | fileSize:1}}</p>\n                </div>\n            </div>\n\n            <h4>{{config.addSectionHeader}}</h4>\n            <input type=\"file\" #fileUpload style=\"display: none;\" [accept]=\"config.accepts\" (change)=\"upload(fileUpload.files, fileUpload)\" />\n            <button class=\"btn btn-bordered\" (click)=\"fileUpload.click();\"><i class=\"fa fa-plus\"></i> {{config.buttonLabel}}</button>\n            <p *ngIf=\"config.accepts.indexOf('image/*') === -1\"><small>Accepted image formats: {{config.accepts}}</small></p>\n            </div>\n        </div>\n    ",
            styles: [
                ".upload-container {\n            display: flex; }",
                ".upload-item {\n            position: relative;\n            display: inline-block;\n            max-width: 120px;\n            text-align: center; }",
                ".upload-item + .upload-item {\n            margin-left: 2rem; }",
                ".upload-title {\n            margin-top: 1rem;\n            word-wrap: break-word; }",
                ".upload-file-size {\n            font-weight: bold; }",
                ".image-area {\n            min-height: 35px;\n            position: relative; }",
                ".image-area > .upload-item-overlay {\n            display: none; }",
                ".image-area:hover > .upload-item-overlay {\n            display: block;\n            position: absolute;\n            width: 100%;\n            height: 100%;\n            background-color: rgba(0,0,0,.6);\n            text-align: right;\n            z-index: 2; }",
                ".remove-upload {\n            font-size: 25px;\n            margin-right: 8px;\n            color: #ff0000;\n            cursor: pointer; }"
            ],
            providers: [forms_1.NgModel]
        }),
        __param(0, core_1.Self()), 
        __metadata('design:paramtypes', [forms_1.NgModel])
    ], ImageUploadComponent);
    return ImageUploadComponent;
}());
exports.ImageUploadComponent = ImageUploadComponent;
//# sourceMappingURL=image-upload.component.js.map